<?php
class CaptchaDemo extends Controller {
    
    function CaptchaDemo() {
        parent::Controller();
    }
    
    function index() {
		$this->load->library('captcha');
		//создаем captcha
		$vals = array(
			'word' => mt_rand(0, 9999),
			'img_path' => str_replace(SELF, "", FCPATH).'uploads'.DIRECTORY_SEPARATOR,
			'img_url' => base_url().'uploads/',
			'font_path' => str_replace(SELF, "", FCPATH).'system'.DIRECTORY_SEPARATOR.'fonts'.DIRECTORY_SEPARATOR.'antsypants.ttf',
			'img_width' => '100',
			'img_height' => '30',
			'expiration' => '7200'
		);
		$cap = $this->captcha->create_captcha($vals);
		//добавляем запись с данными captcha в БД
		$data = array(
			'captcha_id' => '',
			'captcha_time' => $cap['time'],
			'ip_address' => $this->input->ip_address(),
			'word' => $cap['word']
		);
		$query = $this->db->insert_string('captcha', $data);
		$this->db->query($query);
		
		$pageData['title'] = "Тестирование CAPTCHA";
		$pageData['scripts'] = array('js/prototype.js', 'js/checkcaptcha.js');
		$pageData['image'] = $cap['image'];
		$this->load->view('header', $pageData);		
		$this->load->view('captcha');
		$this->load->view('footer');
    }
    
    function ajaxcheck() {
		$this->load->library('validation');

		$rules['check'] = "required|callback_captcha_check";
		$this->validation->set_rules($rules);

		$fields['check'] = "captcha";
		$this->validation->set_fields($fields);

		if ($this->validation->run()) {
		    $res['state'] = "OK";
			//тут будет код, обрабатывающий данные формы
		}
		else {
			$res['state'] = "ERR";
			$res['errMessages'][] = $this->validation->check_error;
		}
		echo json_encode($res);
		return;
    }
	
    function captcha_check($str) {
		$exp = time() - 7200;
		$this->db->query("DELETE FROM captcha WHERE captcha_time < ".$exp);
		$qFind = "SELECT COUNT(*) AS count FROM captcha WHERE word = ? AND ip_address = ? AND captcha_time > ?";
		$data = array($this->input->post('check'), $this->input->ip_address(), $exp);
		$query = $this->db->query($qFind, $data);
		$row = $query->row();
		
		if ($row->count == 0) {
			$this->validation->set_message('captcha_check', 'Введенное число не соотвествует, изображенному на рисунке');
			return FALSE;
		}
		else {
			return TRUE;
		}
	}
}
?> 